# yamllint disable
# License: MIT (c) GitLab Inc.
# yamllint enable
---
rules:
- id: "scala_unsafe_rule-SensitiveDataExposure"
  languages:
  - "scala"
  message: |
    Applications can unintentionally leak information about their configuration, internal
    workings, or violate privacy through a variety of application problems. Pages that provide
    different responses based on the validity of the data can lead to Information Leakage;
    specifically when data deemed confidential is being revealed as a result of the web
    application's design.
  metadata:
    category: "security"
    cwe: "CWE-497"
    shortDescription: "Exposure of sensitive system information to an unauthorized control sphere"
    technology:
    - "scala"
    - "play"
    security-severity: "Info"
  patterns:
  - pattern-inside: |
      def $FUNC(..., $ARG: String, ...) = $TYPE {
        ...
      }
  - pattern-inside: |
      $VAL = ($C: play.api.Configuration).underlying.getString($ARG)
      ...
  - pattern: "Ok(<...$VAL...>)"
  severity: "WARNING"
